﻿using UmlDiagramDesigner.ViewModels.DependentElements;
using UmlDiagramDesigner.ViewModels.DiagramItems;

namespace UmlDiagramDesigner.DTO
{
    public class AttributeBySourceDTO : PropertyChangedDTO
    {
        private ClassDiagramItemViewModel _source;
        private AttributeViewModel _attribute;
        private bool _isSelected;

        public ClassDiagramItemViewModel Source
        {
            get { return _source; }
            set
            {
                if (Equals(value, _source)) return;
                _source = value;
                OnPropertyChanged();
            }
        }

        public AttributeViewModel Attribute
        {
            get { return _attribute; }
            set
            {
                _attribute = value;
                OnPropertyChanged();
            }
        }

        public bool IsSelected
        {
            get { return _isSelected; }
            set
            {
                if (value.Equals(_isSelected)) return;
                _isSelected = value;
                OnPropertyChanged();
            }
        }

        public override int GetHashCode()
        {
            if (Source != null && Attribute != null)
                return Source.GetHashCode() ^ Attribute.GetHashCode();
            else
                return base.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            var dto = obj as AttributeBySourceDTO;
            if (dto == null) return false;

            return dto.Source.Equals(Source) && dto.Attribute.Equals(Attribute);
        }
    }
}
