﻿using System.Linq;
using System.Windows;
using System.Windows.Controls.Primitives;
using UmlDiagramDesigner.ViewModels.DiagramItems;

namespace UmlDiagramDesigner.Helpers.Adorners
{
    public class MoveThumb : DiagramItemThumbBase
    {
        public MoveThumb()
        {
            DragDelta += MoveThumb_DragDelta;
        }

        private void MoveThumb_DragDelta(object sender, DragDeltaEventArgs e)
        {
            var item = DataContext as DiagramItemViewModelBase;

            if (item != null)
            {
                item.LeftPosition += e.HorizontalChange;
                item.TopPosition += e.VerticalChange;

				//var entity = item as EntityDiagramItemViewModel;
				//if (entity != null)
				//{
				//	MoveAllItemsRelationships(e, entity);
				//}
			}
        }

        private static void MoveAllItemsRelationships(DragDeltaEventArgs e, ClassDiagramItemViewModel @class)
        {
            foreach (var relationship in @class.Relationships)
            {
                if (relationship.Source.Equals(@class))
                {
                    var adjusted = new Point(relationship.SourcePoint.X + e.HorizontalChange,
                        relationship.SourcePoint.Y + e.VerticalChange);
                    relationship.SourcePoint = adjusted;
                }
                else
                {
                    var adjusted = new Point(relationship.TargetPoint.X + e.HorizontalChange,
                        relationship.TargetPoint.Y + e.VerticalChange);
                    relationship.TargetPoint = adjusted;
                }
            }
        }
    }
}
