﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;

namespace UmlDiagramDesigner.Helpers
{
    public class SelectAllTextBehaviour : Behavior<TextBox>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            this.AssociatedObject.GotFocus += this.OnTextBoxGotFocus;
            AssociatedObject.PreviewMouseLeftButtonUp += (sender, args) => this.AssociatedObject.SelectAll();
        }

        protected override void OnDetaching()
        {
            this.AssociatedObject.GotFocus -= this.OnTextBoxGotFocus;
            base.OnDetaching();
        }

        private void OnTextBoxGotFocus(object sender, RoutedEventArgs e)
        {
            this.AssociatedObject.SelectAll();
        }

    }
}
