﻿using System.Collections.Generic;
using UmlDiagramDesigner.ViewModels.DiagramItems;

namespace UmlDiagramDesigner.Models
{
    /// <summary>
    /// Takes care of repositioning connections to a specified item(s).
    /// </summary>
    public interface IConnectorEngine
    {
        /// <summary>
        /// Updates connections of provided item.
        /// </summary>
        /// <param name="item">The item.</param>
        void UpdateConnections(DiagramItemViewModelBase item);

        /// <summary>
        /// Updates the connections for the collection of items. Use this for example when loading graph from database.
        /// </summary>
        /// <param name="items">The items.</param>
        void UpdateConnections(IEnumerable<DiagramItemViewModelBase> items);
    }
}