﻿using System;
using System.Windows;
using UmlDiagramDesigner.Core;

namespace UmlDiagramDesigner.Services
{
    public class WpfDialogService : IDialogService
    {
        public void Display(string message)
        {
            MessageBox.Show(message, "Informace", MessageBoxButton.OK, MessageBoxImage.Information);
        }

        public void Display(Exception exception)
        {
            MessageBox.Show(exception.Message, exception.GetType().ToString(), MessageBoxButton.OK,
                MessageBoxImage.Error);
        }

        public void Display(Exception exception, string additionalInfo)
        {
            MessageBox.Show(string.Format("{0}\n\n{1}", additionalInfo, exception.Message),
                exception.GetType().ToString(), MessageBoxButton.OK,
                MessageBoxImage.Error);
        }

        public bool Ask(string question)
        {
            var result = MessageBox.Show(question, "Potvrzení", MessageBoxButton.YesNo, MessageBoxImage.Question);

            return result == MessageBoxResult.Yes;
        }
    }
}
