﻿using System;
using System.Windows.Input;

namespace UmlDiagramDesigner.ViewModels.Commands
{
    public class GenericCommand : ICommand
    {
        private readonly Action _action;
        private readonly bool _canExecute;

        public GenericCommand(Action action, bool canExecute = true)
        {
            _action = action;
            _canExecute = canExecute;
        }

        public bool CanExecute(object parameter)
        {
            //zde lze implementovat libovolnou logiku pro vyhodnocení, zda
            //se má Command spustit
            return true;
        }

        public void Execute(object parameter)
        {
            if(_canExecute)
                _action();
        }

        private void RaiseCanExecuteChangedEvent()
        {
            if(CanExecuteChanged != null)
                CanExecuteChanged(this,EventArgs.Empty);
        }

        public event EventHandler CanExecuteChanged;
    }
}
