﻿using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.ViewModels.DependentElements
{
    public class TriggerViewModel : ViewModelBase
    {
        private string _name;
        private TriggerEvent _event;

        public TriggerViewModel()
        {
            Name = "triggerName";
        }

        #region Properties

        public string Name
        {
            get { return _name; }
            set { _name = value; OnPropertyChanged(); OnPropertyChanged("FormattedString"); }
        }

        public TriggerEvent Event
        {
            get { return _event; }
            set { _event = value; OnPropertyChanged(); OnPropertyChanged("FormattedString"); }
        }

        public string FormattedString { get { return ToString(); } }

        #endregion

        public override string ToString()
        {
            return string.Format("{0}(...) <<Trigger>> {{event ={1}}}", Name, Event);
        }
    }
}
