﻿using System;
using UmlDiagramDesigner.ViewModels.InputForms;
using UmlDiagramDesigner.Views.InputForms;

namespace UmlDiagramDesigner.ViewModels.DiagramItems
{
    public class CommentDiagramItemViewModel : DiagramItemViewModelBase
    {
        private string _text;
        private TextInputViewModel _textInputViewModel;
        private DateTime _dateCreated;

        public CommentDiagramItemViewModel()
        {
            Text = "Enter some text...";
            DateCreated = DateTime.Now;
        }

        #region Properties

        public string Text
        {
            get { return _text; }
            set
            {
                if (value == _text) return;
                _text = value;
                OnPropertyChanged();
            }
        }

        public DateTime DateCreated
        {
            get { return _dateCreated; }
            set { _dateCreated = value;OnPropertyChanged(); }
        }

        #endregion

        protected override void EditItem()
        {
            var dialog = new TextInputWindow();
            dialog.DataContext = _textInputViewModel = new TextInputViewModel(Text) {InputValueName = "Comment text: "};

            _textInputViewModel.InputCompleted += (sender, args) => Text = _textInputViewModel.Text;

            dialog.ShowDialog();
        }

        public override string GetResourceStyleName()
        {
            return "CommentStyle";
        }
    }
}
