﻿using System;
using UmlDiagramDesigner.Core.Enums;
using UmlDiagramDesigner.Models.Attributes;
using UmlDiagramDesigner.ViewModels.DependentElements;

namespace UmlDiagramDesigner.ViewModels.DiagramRelationships
{
    [AllowMultiple]
    //[RequiresConstraint(SqlConstraint.PrimaryKey | SqlConstraint.Unique)]
    public class DependencyViewModel : RelationshipViewModelBase
    {
        public override string GetResourceStyleName()
        {
            return "DependencyStyle";
        }

        private void RaiseAttributeChangedEvent(AttributeViewModel attribute)
        {
            if (AttributeChanged != null)
                AttributeChanged(this, attribute);
        }

        private void RaiseAttributeRemovedEvent(AttributeViewModel attribute)
        {
            if (AttributeRemoved != null)
                AttributeRemoved(this, attribute);
        }

        public override string ToString()
        {
            return "Dependency";
        }

        public event EventHandler<AttributeViewModel> AttributeChanged;
        public event EventHandler<AttributeViewModel> AttributeRemoved;
    }
}
