﻿using System;
using System.Collections.Generic;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.ViewModels.InputForms
{
    public class TriggerInputViewModel : InputFormViewModelBase
    {
        private TriggerEvent _triggerEvent;
        private string _name;
        private string _innerCode;

        public TriggerInputViewModel()
        {
            
        }

        #region Properties

        public string Name
        {
            get { return _name; }
            set
            {
                if (value == _name) return;
                _name = value;
                OnPropertyChanged();
            }
        }

        public TriggerEvent TriggerEvent
        {
            get { return _triggerEvent; }
            set
            {
                if (value == _triggerEvent) return;
                _triggerEvent = value;
                OnPropertyChanged();
            }
        }

        public IEnumerable<string> ReactionTypes
        {
            get { return Enum.GetNames(typeof (TriggerEvent)); }
        }

        public string InnerCode
        {
            get { return _innerCode; }
            set
            {
                if (value == _innerCode) return;
                _innerCode = value;
                OnPropertyChanged();
            }
        }

        #endregion



        protected override bool ValidateInputData()
        {
            if (string.IsNullOrEmpty(Name))
                return SetErrorText("Musíte zadat název triggeru.");

            return true;
        }
    }
}
