﻿using System;
using UmlDiagramDesigner.Properties;

namespace UmlDiagramDesigner.ViewModels
{
    public class ToolboxItemViewModel
    {
        #region Variables

        private readonly string _itemName, _itemDescription, _imageUrl;
        private readonly Type _diagramItemType;

        #endregion

        #region Constructors

        public ToolboxItemViewModel(string itemName, string itemDescription, string imageUrl, Type diagramItemType)
        {
            _itemName = itemName;
            _itemDescription = itemDescription;
            _imageUrl = imageUrl;
            _diagramItemType = diagramItemType;
        }

        #endregion

        #region Properties

        public string ItemName
        {
            get { return _itemName; }
        }

        public string ItemDescription
        {
            get { return _itemDescription; }
        }

        public string ImageUrl
        {
            get { return _imageUrl; }
        }

        public Type DiagramItemType
        {
            get { return _diagramItemType; }
        }

        public double DefaultWidth
        {
            get { return Settings.Default.DefaultItemWidth; }
        }

        public double DefaultHeight
        {
            get { return Settings.Default.DefaultItemHeight; }
        }

        public double DefaultMinHeight
        {
            get { return 0; }
        }

        public double DefaultMinWidth
        {
            get { return 0; }
        }

        #endregion

        public override int GetHashCode()
        {
            return _itemName.GetHashCode() ^ _itemDescription.GetHashCode() - _imageUrl.GetHashCode();
        }
    }
}

