﻿using System;
using System.ComponentModel;
using System.Windows;
using UmlDiagramDesigner.Core;
using UmlDiagramDesigner.Models;
using UmlDiagramDesigner.Properties;
using UmlDiagramDesigner.Services;
using UmlDiagramDesigner.ViewModels;

namespace UmlDiagramDesigner.Views
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private IDialogService _dialogService;

        public MainWindow()
        {
            _dialogService = new WpfDialogService();
            InitializeComponent();
            Instance = this;
        }

        public static MainWindow Instance { get; private set; }

        protected override void OnClosing(CancelEventArgs e)
        {
            if (ChangeTracker.Instance.IsTracking && ChangeTracker.Instance.HasChanged(CanvasViewModel.Instance))
            {
                if (
                    _dialogService.Ask(
                        "There are some unsaved changes, are you sure you want to exit?"))
                {
                    Settings.Default.Save();
                    Application.Current.Shutdown();
                }
                else
                {
                    e.Cancel = true;
                }
            }
        }

        public void Connect(int connectionId, object target)
        {
            throw new NotImplementedException();
        }
    }
}
