﻿using System.Collections.Generic;
using System.Data;
using UmlDiagramDesigner.CodeGeneration.Enums;
using UmlDiagramDesigner.Core.Enums;
using ForeignKeyConstraint = UmlDiagramDesigner.Data.ForeignKeyConstraint;

namespace UmlDiagramDesigner.CodeGeneration.Contracts
{
	/// <summary>
	/// Defines abstract programming language properties.
	/// </summary>
	public interface ILanguageProperties
    {
		/// <summary>
		/// Gets the dictionary of language features.
		/// </summary>
		/// <value>
		/// The features.
		/// </value>
		Dictionary<LanguageFeature, string> Features { get; }
		/// <summary>
		/// Gets the dictionary of language data types.
		/// </summary>
		/// <value>
		/// The data types.
		/// </value>
		Dictionary<DbDataType, string> DataTypes { get; }
    }
}
