﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Data;

namespace UmlDiagramDesigner.CodeGeneration.Contracts
{
	/// <summary>
	/// Defines an algorithm for generating SQL tables.
	/// </summary>
	public interface ISqlTableGenerator
    {
		/// <summary>
		/// Generates the tables. Takes care of generating junction tables if necessary.
		/// </summary>
		/// <param name="classes">The classes.</param>
		/// <returns></returns>
		string GenerateTables(IEnumerable<Class> classes);
		/// <summary>
		/// Gets or sets the SQL properties.
		/// </summary>
		/// <value>
		/// The SQL properties.
		/// </value>
		ISqlProperties SqlProperties { get; set; }
    }
}
