﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Data;

namespace UmlDiagramDesigner.CodeGeneration.DTO
{
	/// <summary>
	/// Class for holding data of several classes. 
	/// </summary>
	public class CombinedClassDTO
    {
        public CombinedClassDTO()
        {
            ForeignKeys = new HashSet<ForeignKeyConstraint>();
            Attributes = new HashSet<DataAttribute>();
        }

		/// <summary>
		/// Gets or sets the name.
		/// </summary>
		/// <value>
		/// The name.
		/// </value>
		public string Name { get; set; }
		/// <summary>
		/// Gets or sets the primary key.
		/// </summary>
		/// <value>
		/// The primary key.
		/// </value>
		public PrimaryKey PrimaryKey { get; set; }
		/// <summary>
		/// Gets or sets the foreign keys.
		/// </summary>
		/// <value>
		/// The foreign keys.
		/// </value>
		public HashSet<ForeignKeyConstraint> ForeignKeys { get; set; }
		/// <summary>
		/// Gets or sets the attributes.
		/// </summary>
		/// <value>
		/// The attributes.
		/// </value>
		public HashSet<DataAttribute> Attributes { get; set; }
		/// <summary>
		/// Gets or sets the collection of classes which the class is combined of.
		/// </summary>
		/// <value>
		/// The combined of.
		/// </value>
		public ICollection<Class> CombinedOf { get; set; }
    }
}
