﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.CodeGeneration.Contracts;
using UmlDiagramDesigner.CodeGeneration.Enums;
using UmlDiagramDesigner.Core.Enums;
using UmlDiagramDesigner.Data;

namespace UmlDiagramDesigner.CodeGeneration
{
	/// <summary>
	/// Concrete properties for Smalltalk language.
	/// </summary>
	public class SmallTalkProperties : IOopLanguageProperties
    {
        private Dictionary<LanguageFeature, string> _features; 

        public Dictionary<LanguageFeature, string> Features
        {
            get { return _features ?? (_features = new Dictionary<LanguageFeature, string>()
            {
                {LanguageFeature.Comment, "\""}
            }); }
        }

        public Dictionary<Accessibility, string> Accessibilities
        {
            get { return new Dictionary<Accessibility, string>();}
        }

        public Dictionary<DbDataType, string> DataTypes
        {
            get { return new Dictionary<DbDataType, string>();}
        }

        public string GenerateNavPropertyDataType(ForeignKeyConstraint navigationProperty)
        {
            return string.Empty;
        }
    }
}
