﻿using System.Collections.Generic;

namespace UmlDiagramDesigner.Core.Graph
{
	/// <summary>
	/// Defines a generic vertex.
	/// </summary>
	public interface IVertex
    {
		/// <summary>
		/// Gets the neighbours.
		/// </summary>
		/// <param name="revert">if set to <c>true</c> [revert].</param>
		/// <returns></returns>
		IEnumerable<IVertex> GetNeighbours(bool revert = false);
		/// <summary>
		/// Gets the neighbours connected with T association.
		/// </summary>
		/// <typeparam name="T"></typeparam>
		/// <param name="revert">if set to <c>true</c> [revert].</param>
		/// <returns></returns>
		IEnumerable<IVertex> GetNeighbours<T>(bool revert = false) where T : class;
    }
}
