﻿using System.Collections.Generic;
using UmlDiagramDesigner.Core.Graph;

namespace UmlDiagramDesigner.Core
{
	/// <summary>
	/// Cycle detection algorithm.
	/// </summary>
	public interface ICycleDetector
    {
        /// <summary>
        /// Detects all cycles of any edge in given graph.
        /// </summary>
        /// <param name="graph">The graph.</param>
        /// <returns>Found collections of item, that make a cycle</returns>
        IReadOnlyCollection<IList<IIndexedVertex>> DetectCycles(IIndexedGraph graph);

        /// <summary>
        /// Detects all cycles of T edge in given graph.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="graph">The graph.</param>
        /// <returns></returns>
        IReadOnlyCollection<IList<IIndexedVertex>> DetectCycles<T>(IIndexedGraph graph) where T : class;
    }
}