﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.Core
{
	/// <summary>
	/// Interface for implementation of providing available points to which associations can connect to.
	/// </summary>
	public interface IPointProvider
    {
        /// <summary>
        /// Gets the available points.
        /// </summary>
        /// <returns></returns>
        Point[] GetAvailablePoints();
        /// <summary>
        /// Gets the available points from provided position.
        /// </summary>
        /// <param name="position">The position.</param>
        /// <returns></returns>
        Point[] GetAvailablePoints(RelativePosition position);
    }
}
