﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Core.Graph;

namespace UmlDiagramDesigner.Data
{
	/// <summary>
	/// <see cref="IIndexedGraph"/> implementation. Contrains classes and views on model.
	/// </summary>
	public class Diagram : IIndexedGraph
    {
		/// <summary>
		/// Gets or sets the name.
		/// </summary>
		/// <value>
		/// The name.
		/// </value>
		public string Name { get; set; }
		/// <summary>
		/// Gets or sets the classes.
		/// </summary>
		/// <value>
		/// The classes.
		/// </value>
		public ICollection<Class> Classes { get; set; }
		/// <summary>
		/// Gets or sets the views.
		/// </summary>
		/// <value>
		/// The views.
		/// </value>
		public ICollection<View> Views { get; set; }
        public IEnumerable<IIndexedVertex> GetVertices()
        {
            return Classes;
        }
    }
}
