﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.Data
{
	/// <summary>
	/// Foreign key constraint.
	/// </summary>
	public class ForeignKeyConstraint : DataAttribute
    {
		/// <summary>
		/// Gets or sets the <see cref="PrimaryKey"/> that this FK references.
		/// </summary>
		/// <value>
		/// The references.
		/// </value>
		public PrimaryKey References { get; set; }
		/// <summary>
		/// Gets or sets the source multiplicity.
		/// </summary>
		/// <value>
		/// The source multiplicity.
		/// </value>
		public MultiplicityType SourceMultiplicity { get; set; }
		/// <summary>
		/// Gets or sets the target multiplicity.
		/// </summary>
		/// <value>
		/// The target multiplicity.
		/// </value>
		public MultiplicityType TargetMultiplicity { get; set; }
    }
}
