﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.Data
{
	/// <summary>
	/// SQL trigger.
	/// </summary>
	public class Trigger
    {
		/// <summary>
		/// Gets or sets the name.
		/// </summary>
		/// <value>
		/// The name.
		/// </value>
		public string Name { get; set; }
		/// <summary>
		/// Gets or sets the event which triggers this trigger.
		/// </summary>
		/// <value>
		/// The event.
		/// </value>
		public TriggerEvent Event { get; set; }
		/// <summary>
		/// Gets or sets the on table, that contains this trigger.
		/// </summary>
		/// <value>
		/// The on table.
		/// </value>
		public Class OnTable { get; set; }
    }
}
